from jpype import *
from numpy import *

class Inference():
    '''
    classdocs
    '''

    def __init__(self, networkpath, licensekey):
        '''
        Constructor
        '''
        startJVM(getDefaultJVMPath(), classpath=['lib/BayesiaEngine.jar','lib/xercesImpl.jar','lib/xml-apis.jar','lib/xml-apis-ext.jar','lib/batik-all.jar'], ignoreUnrecognized=True, convertStrings=True)
        apipackage = JPackage("com.bayesia.api")
        self.inference = apipackage.APIInference(networkpath, licensekey, apipackage.APIInference.EXACT_INFERENCE); 
        
    def close(self):
        shutdownJVM()
        
    def getinference(self):
        return self.inference
    

infer = Inference('S2E3IRD_France_h2_Opt_ADR.xbl', '______________________')
apiInf = infer.getinference()
sep = ';'
newline = '\n'
outvar = 'ErrHosp_Cum'

var1 = 'ar'
fvar1 = 'Asympt'
min1 = 0.2
max1 = 0.3
nb1 = 11
range1 = linspace(min1, max1, nb1)

var2 = 'ds'
fvar2 = 'DSick'
min2 = 0.456
max2 = 0.528
nb2 = 4
range2 = linspace(min2, max2, nb2)

var3 = 'r_0'
fvar3 = 'R0'
min3 = 0.0280
max3 = 0.0290
nb3 = 11
range3 =  linspace(min3, max3, nb3)

f = open('output_ADR.csv', 'w', buffering=1)
f.write(fvar1)  
f.write(sep)  
f.write(fvar2)  
f.write(sep)  
f.write(fvar3)  
f.write(sep)  
f.write(outvar)     
f.write(newline) 

total = nb1 * nb2 * nb3
current = 0

array1 = JArray(JDouble)([0, 0])
array2 = JArray(JDouble)([0, 0])
array3 = JArray(JDouble)([0, 0])
for p1 in range1:
    array1[0] = 1 - p1
    array1[1] = p1
    for p2 in range2:
        array2[0] = 1 - p2
        array2[1] = p2
        for p3 in range3:
            array3[0] = 1 - p3
            array3[1] = p3
            apiInf.setObservedProbabilities(var1, array1)
            apiInf.setObservedProbabilities(var2, array2)
            apiInf.setObservedProbabilities(var3, array3)
            
            apiInf.setTime(3999);
            
            f.write(str(apiInf.getFunctionValue(fvar1).getNumber().doubleValue()))
            f.write(sep)
            f.write(str(apiInf.getFunctionValue(fvar2).getNumber().doubleValue()))
            f.write(sep)
            f.write(str(apiInf.getFunctionValue(fvar3).getNumber().doubleValue()))
            f.write(sep)
            f.write(str(apiInf.getFunctionValue(outvar).getNumber().doubleValue()))
            f.write(newline)
            
            infer.getinference().resetTime()
            current = current + 1
            print(current / total * 100, '%')
f.close()
infer.close()
